SystemOrganization addCategory: #'Seaside-Tests-Adaptors-Comanche'!

WADocumentHandlerResponseTest subclass: #WAComancheDocumentHandlerResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Adaptors-Comanche'!

!WAComancheDocumentHandlerResponseTest methodsFor: 'testing' stamp: 'pmm 2/16/2011 22:21'!
assertHttpResponseFrom: aResponse matches: aHandler 
	| httpResponse kom |
	super 
		assertHttpResponseFrom: aResponse
		matches: aHandler.
	kom := WAComancheAdaptor new.
	httpResponse := [ kom responseFrom: self requestContext ]
		ensure: [ kom unregister ].
	self assert: httpResponse status == #ok.
	self assert: httpResponse contentType = aHandler document mimeType greaseString.
	self assert: httpResponse contentLength = aHandler document contents size.
	httpResponse fields keysAndValuesDo:  [ :key :value | 
		self assert: (self 
				headerAt: key
				forResponse: aResponse) greaseString = value ].
	aResponse headers keysAndValuesDo:  [ :key :value | 
		self assert: (key = 'Content-Type' or: [ (httpResponse fields at: key) = value greaseString ]) ].
	self assert: httpResponse cookies isEmpty! !

!GRPackage class methodsFor: '*seaside-tests-adaptors-comanche' stamp: 'lr 2/17/2010 15:13'!
seasideTestsAdaptorsComanche
	^ self new
		name: 'Seaside-Tests-Adaptors-Comanche';
		description: 'Unit tests for the package Seaside-Adaptors-Comanche.';
		addDependency: 'Seaside-Adaptors-Comanche';
		addDependency: 'Seaside-Tests-Pharo-Core';
		url: #seasideUrl;
		yourself! !

!WACookieTest methodsFor: '*seaside-tests-adaptors-comanche' stamp: 'pmm 9/8/2013 14:44'!
testWriteOnWithoutKey
	| expiry cookie |
	expiry := DateAndTime year: 2007 month: 11 day: 21 hour: 14 minute: 42 second: 48 offset: (Duration days: 0 hours: 2 minutes: 0 seconds: 0).
	cookie := WACookie key: 'ikuser' value: '1234'.
	
	cookie expiry: expiry.
	cookie maxAge: 3600.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT'.
	
	cookie path: '/seaside/counter'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	
	cookie value: nil.
	self assert: cookie oldNetscapeStringWithoutKey = '; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	
	cookie value: '1234'.
	cookie domain: 'www.example.com'.
	cookie ports: (Array with: 80 with: 433).
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com'.
	
	cookie discard: true.
	cookie secure: true.
	cookie httpOnly: true.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'.
	
	cookie comment: 'FIS Heer username'.
	cookie commentUrl: 'http://www.example.com/session-cookie.html'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'! !
